Index: protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/OptInPhase.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/OptInPhase.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/OptInPhase.java	(revision 30)
@@ -0,0 +1,110 @@
+package geniusweb.protocol.session.mopac2.phase;
+
+import java.util.Arrays;
+import java.util.List;
+import java.util.Map;
+import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.PartyId;
+import geniusweb.actions.Votes;
+import geniusweb.actions.VotesWithValue;
+import geniusweb.inform.Agreements;
+import geniusweb.inform.Inform;
+import geniusweb.inform.OptInWithValue;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.session.mopac2.PartyStates;
+import geniusweb.voting.CollectedVotesWithValue;
+import geniusweb.voting.VotingEvaluatorWithValue;
+
+public class OptInPhase extends DefaultPhase {
+
+	/**
+	 * The votes received in the {@link VotingPhase}
+	 */
+	private final List<VotesWithValue> votes;
+
+	@JsonCreator
+	protected OptInPhase(@JsonProperty("votes") List<VotesWithValue> votes,
+			@JsonProperty("partyStates") PartyStates partyStates,
+			@JsonProperty("deadlinems") Long deadlinems,
+			@JsonProperty("evaluator") VotingEvaluatorWithValue evaluator) {
+		super(partyStates, deadlinems, evaluator);
+		this.votes = votes;
+	}
+
+	@Override
+	public Inform getInform() {
+		return new OptInWithValue(votes);
+	}
+
+	@Override
+	public Phase with(PartyId actor, Action action, long now) {
+		try {
+			checkAction(actor, action, now);
+			if (action instanceof VotesWithValue)
+				checkExtends((VotesWithValue) action);
+
+			return new OptInPhase(votes, partyStates.with(action), deadline,
+					evaluator);
+
+		} catch (ProtocolException e) {
+			return this.with(e);
+		}
+	}
+
+	/**
+	 * Check that this action extends previous action.
+	 * 
+	 * @param newvotes new {@link Votes} just received
+	 * @throws ProtocolException if this action does not correctly extend
+	 *                           previous vote.
+	 */
+	private void checkExtends(VotesWithValue newvotes)
+			throws ProtocolException {
+		PartyId actor = newvotes.getActor();
+		// this actor is active so he must have voted in previous round.
+		VotesWithValue prevVotes = votes.stream()
+				.filter(v -> v.getActor().equals(actor)).findFirst().get();
+		if (!(newvotes.isExtending(prevVotes)))
+			throw new ProtocolException("New votes " + newvotes
+					+ " does not extend previous vote " + prevVotes, actor);
+	}
+
+	@Override
+	public OptInPhase with(ProtocolException e) {
+		return new OptInPhase(votes, partyStates.with(e), deadline, evaluator);
+	}
+
+	@Override
+	public OptInPhase finish() {
+		PartyStates states = partyStates.finish();
+		Map<PartyId, VotesWithValue> votesmap = states
+				.getActions(VotesWithValue.class).stream()
+				.collect(Collectors.toMap(vts -> vts.getActor(), v -> v));
+		CollectedVotesWithValue allvotes = new CollectedVotesWithValue(votesmap,
+				states.getPowers());
+		Agreements newAgree = evaluator.create(allvotes).getAgreements();
+		if (!newAgree.getMap().isEmpty()) {
+			System.out.println("detected new agreements");
+		}
+		PartyStates finalStates = states.with(newAgree);
+
+		return new OptInPhase(votes, finalStates, deadline, evaluator);
+	}
+
+	@Override
+	public OfferPhase checkedNext(long newdeadline) {
+		return new OfferPhase(partyStates.flush(), newdeadline, evaluator);
+	}
+
+	@Override
+	public List<Class<? extends Action>> getAllowedActions() {
+		return Arrays.asList(VotesWithValue.class, EndNegotiation.class);
+	}
+
+}
Index: protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/Phase.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/Phase.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/Phase.java	(revision 30)
@@ -0,0 +1,121 @@
+package geniusweb.protocol.session.mopac2.phase;
+
+import java.util.List;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonSubTypes;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Inform;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.session.mopac2.PartyStates;
+import geniusweb.voting.VotingEvaluatorWithValue;
+
+/**
+ * A Phase is a part of the round structure. In each round parties have to take
+ * multiple actions. Each action is part of a phase.
+ * 
+ * Invariant: A phase object handles negotiation events, ensuring that the
+ * events are handled according to the possible actions in this phase. A phase
+ * object must always remain in a consistent state. It does so by modifying the
+ * contained {@link PartyStates} as needed.
+ * <p>
+ * The standard exception handling is assumed: unchecked exceptions are thrown
+ * only if there is a bug in the protocol. Because none of the functions in this
+ * interface throws, any error must be either ignored or the party must be
+ * kicked.
+ */
+@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
+@JsonSubTypes({ @JsonSubTypes.Type(value = OfferPhase.class),
+		@JsonSubTypes.Type(value = OptInPhase.class),
+		@JsonSubTypes.Type(value = VotingPhase.class) })
+public interface Phase {
+	public static final Long PHASE_MAXTIME = 30000l; // 30sec
+	public static final Long PHASE_MINTIME = 100l; // 100 millisec
+
+	/**
+	 * Handle an actor's action. If a {@link ProtocolException} occurs, this is
+	 * handled by updating the PartyStates
+	 * 
+	 * @param actor  the real actor (may differ from the actor contained in the
+	 *               action)
+	 * @param action the action submitted by actor, which this phase can really
+	 *               handle.
+	 * @param now    the current time
+	 * @return new VotingPhase
+	 */
+	public Phase with(PartyId actor, Action action, long now);
+
+	/**
+	 * 
+	 * @param e a {@link ProtocolException}
+	 * @return new Phase with a party disabled because it violated a protocol eg
+	 *         breaking a websocket link.
+	 */
+	public Phase with(ProtocolException e);
+
+	/**
+	 * 
+	 * @return the inform object to send to all parties at start of phase.
+	 */
+	public Inform getInform();
+
+	/**
+	 * 
+	 * @param now the current time
+	 * @return true iff past deadline or no more actions are allowed anyway.
+	 *         (which usually means, all parties have done exactly one act).
+	 *         Notice, this is the main reason that it is desirable to require
+	 *         all parties to act exactly once in each phase. Without such a
+	 *         rule, the protocol will always have to wait till the deadline.
+	 */
+	public boolean isFinal(long now);
+
+	/**
+	 * 
+	 * @return finished state. That means, all parties that did not act have
+	 *         been kicked, new agreements have been computed, etc.
+	 */
+	public Phase finish();
+
+	/**
+	 * Determines the next phase. Resets the actions field. Can only be called
+	 * after {@link #finish()}
+	 * 
+	 * @param now      the current time
+	 * @param duration the max duration (ms) of the next phase. Must be between
+	 *                 {@link #PHASE_MINTIME} and {@link #PHASE_MAXTIME}. Also
+	 *                 make sure that now+duration is at most at the total
+	 *                 negotiation deadline.
+	 * @return the next phase, or null if negotiation is complete.
+	 */
+	public Phase next(long now, long duration);
+
+	/**
+	 * @return the voting evaluator
+	 */
+	public VotingEvaluatorWithValue getEvaluator();
+
+	/**
+	 * 
+	 * @return time (ms since 1970) at which phase ends. The phase may end
+	 *         before, but never after this.
+	 */
+	public long getDeadline();
+
+	/**
+	 * @return the party states. Notice that someone must call
+	 *         {@link PartyStates#finish()} if passed the deadline.
+	 */
+	public PartyStates getPartyStates();
+
+	/**
+	 * @return the allowed actinos in this phase
+	 */
+	public abstract List<Class<? extends Action>> getAllowedActions();
+
+}
Index: protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/VotingPhase.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/VotingPhase.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/mopac2/phase/VotingPhase.java	(revision 30)
@@ -0,0 +1,85 @@
+package geniusweb.protocol.session.mopac2.phase;
+
+import java.util.Arrays;
+import java.util.List;
+import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.Offer;
+import geniusweb.actions.PartyId;
+import geniusweb.actions.VotesWithValue;
+import geniusweb.inform.Inform;
+import geniusweb.inform.Voting;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.session.mopac2.PartyStates;
+import geniusweb.voting.VotingEvaluatorWithValue;
+
+public class VotingPhase extends DefaultPhase {
+
+	/**
+	 * the offers received in the {@link OfferPhase}
+	 */
+	private final List<Offer> offers;
+
+	@JsonCreator
+	protected VotingPhase(@JsonProperty("offers") List<Offer> offers,
+			@JsonProperty("partyStates") PartyStates partyStates,
+			@JsonProperty("deadlinems") Long deadlinems,
+			@JsonProperty("evaluator") VotingEvaluatorWithValue evaluator) {
+		super(partyStates, deadlinems, evaluator);
+		this.offers = offers;
+	}
+
+	@Override
+	public VotingPhase with(PartyId actor, Action action, long now) {
+		try {
+			checkAction(actor, action, now);
+		} catch (ProtocolException ex) {
+			return this.with(ex);
+		}
+		return new VotingPhase(offers, partyStates.with(action), deadline,
+				evaluator);
+	}
+
+	@Override
+	public Inform getInform() {
+		return new Voting(offers, partyStates.getPowers());
+	}
+
+	@Override
+	public VotingPhase with(ProtocolException e) {
+		return new VotingPhase(offers, partyStates.with(e), deadline,
+				evaluator);
+	}
+
+	@Override
+	public VotingPhase finish() {
+		return new VotingPhase(offers, partyStates.finish(), deadline,
+				evaluator);
+	}
+
+	@Override
+	protected Phase checkedNext(long deadln) {
+		return new OptInPhase(getVotes(), partyStates.flush(), deadln,
+				evaluator);
+	}
+
+	@Override
+	public List<Class<? extends Action>> getAllowedActions() {
+		return Arrays.asList(VotesWithValue.class, EndNegotiation.class);
+	}
+
+	/**
+	 * @return all votes done in this phase.
+	 */
+	public List<VotesWithValue> getVotes() {
+		return partyStates.getActions().stream()
+				.filter(act -> act instanceof VotesWithValue)
+				.map(act -> (VotesWithValue) act).collect(Collectors.toList());
+	}
+
+}
Index: protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java	(revision 29)
+++ protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java	(revision 30)
@@ -10,13 +10,12 @@
 
 import geniusweb.deadline.Deadline;
-import geniusweb.protocol.session.OnePartyTeam;
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
-import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
+import geniusweb.protocol.session.TeamInfo;
 import geniusweb.references.PartyWithProfile;
 import tudelft.utilities.logging.Reporter;
 
 public class SAOPSettings implements SessionSettings {
-	private final List<OnePartyTeam> participants;
+	private final List<TeamInfo> participants;
 	private final Deadline deadline;
 
@@ -31,5 +30,5 @@
 	@JsonCreator
 	public SAOPSettings(
-			@JsonProperty("participants") List<OnePartyTeam> participants,
+			@JsonProperty("participants") List<TeamInfo> participants,
 			@JsonProperty("deadline") Deadline deadline) {
 		this.participants = participants;
@@ -54,5 +53,5 @@
 
 	@Override
-	public List<TeamOfPartiesAndProfiles> getTeams() {
+	public List<TeamInfo> getTeams() {
 		return Collections.unmodifiableList(participants);
 	}
@@ -70,4 +69,9 @@
 				.map(particip -> particip.getAllParties().get(0))
 				.collect(Collectors.toList());
+	}
+
+	@Override
+	public Integer getTeamSize() {
+		return 1;
 	}
 
@@ -111,10 +115,11 @@
 
 	@Override
-	public SessionSettings with(TeamOfPartiesAndProfiles party) {
-		if (!(party instanceof OnePartyTeam))
+	public SessionSettings with(TeamInfo team) {
+		if (team.getSize() != 1)
 			throw new IllegalArgumentException(
-					"Added party must be OnePartyTeam but got " + party);
-		List<OnePartyTeam> newparts = new LinkedList<>(participants);
-		newparts.add((OnePartyTeam) party);
+					"Team must be size 1 but found " + team);
+		List<TeamInfo> newparts = new LinkedList<>(
+				participants);
+		newparts.add(team);
 		return new SAOPSettings(newparts, deadline);
 	}
Index: protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java	(revision 29)
+++ protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOP.java	(revision 30)
@@ -33,4 +33,5 @@
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionState;
+import geniusweb.protocol.session.TeamInfo;
 import geniusweb.references.Parameters;
 import geniusweb.references.PartyWithProfile;
@@ -59,5 +60,5 @@
  * <p>
  * The Comparison/ComparisonTest actions are private between the
- * {@link ShaopTeam}. A SHAOP party can do a {@link ElicitComparison} action at
+ * {@link TeamInfo}. A SHAOP party can do a {@link ElicitComparison} action at
  * any time. These actions are completely transparent to the other parties and
  * are not dependent or influencing the normal turn taking.
@@ -80,5 +81,5 @@
 			false);
 	private volatile Timer deadlinetimer = null;
-	private List<Class> ALLOWED_ACTIONS = Arrays.asList(Offer.class,
+	private List ALLOWED_ACTIONS = Arrays.asList(Offer.class,
 			ElicitComparison.class, Accept.class, EndNegotiation.class);
 
Index: protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPSettings.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPSettings.java	(revision 29)
+++ protocol/src/main/java/geniusweb/protocol/session/shaop/SHAOPSettings.java	(revision 30)
@@ -13,22 +13,25 @@
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
-import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
+import geniusweb.protocol.session.TeamInfo;
 import geniusweb.references.PartyWithProfile;
 import tudelft.utilities.logging.Reporter;
 
 public class SHAOPSettings implements SessionSettings {
-	private final List<ShaopTeam> participants;
+	private static final int SHAOP = 0;
+	private static final int COB = 1;
+	private final List<TeamInfo> participants;
 	private final Deadline deadline;
 	private final transient List<PartyWithProfile> allParties = new LinkedList<>();
 
 	/**
-	 * @param teams    the list of {@link ShaopTeam}s containing the shaop
-	 *                 parties and their partner cob There must be at least 2 to
-	 *                 run the SHAOP protocol. But SHAOP can be initialized with
-	 *                 less, for use in TournamentSettings.
+	 * @param teams    the {@link TeamInfo}s each containing the shaop parties
+	 *                 and their partner cob, in that order. There must be at
+	 *                 least 2 {@link TeamInfo}s to run the SHAOP protocol. But
+	 *                 SHAOP can be initialized with less, for use in
+	 *                 TournamentSettings.
 	 * @param deadline the deadline settings for the session
 	 */
 	@JsonCreator
-	public SHAOPSettings(@JsonProperty("participants") List<ShaopTeam> teams,
+	public SHAOPSettings(@JsonProperty("participants") List<TeamInfo> teams,
 			@JsonProperty("deadline") Deadline deadline) {
 		if (teams == null)
@@ -39,7 +42,10 @@
 		this.deadline = deadline;
 		// notice, order here is crucial because of way #isShaopParty works.
-		for (ShaopTeam tuple : teams) {
-			allParties.add(tuple.getShaop());
-			allParties.add(tuple.getCob());
+		for (TeamInfo team : teams) {
+			if (team.getSize() != 2)
+				throw new IllegalArgumentException(
+						"Team must be size 2 but found " + team);
+			allParties.add(team.getAllParties().get(SHAOP));
+			allParties.add(team.getAllParties().get(COB));
 		}
 	}
@@ -56,7 +62,7 @@
 
 	@Override
-	public List<TeamOfPartiesAndProfiles> getTeams() {
+	public List<TeamInfo> getTeams() {
 		// cast needed...
-		return new ArrayList<TeamOfPartiesAndProfiles>(participants);
+		return new ArrayList<TeamInfo>(participants);
 	}
 
@@ -81,11 +87,13 @@
 
 	@Override
-	public SessionSettings with(TeamOfPartiesAndProfiles party) {
-		if (!(party instanceof ShaopTeam))
-			throw new IllegalArgumentException(
-					"Added party must be ShaopTeam but got " + party);
-		List<ShaopTeam> newparts = new LinkedList<>(participants);
-		newparts.add((ShaopTeam) party);
+	public SessionSettings with(TeamInfo team) {
+		List<TeamInfo> newparts = new LinkedList<>(participants);
+		newparts.add(team);
 		return new SHAOPSettings(newparts, deadline);
+	}
+
+	@Override
+	public Integer getTeamSize() {
+		return 2;
 	}
 
Index: protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java	(revision 29)
+++ protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java	(revision 30)
@@ -3,4 +3,5 @@
 import java.math.BigInteger;
 import java.util.Collections;
+import java.util.LinkedList;
 import java.util.List;
 import java.util.function.BiFunction;
@@ -9,15 +10,13 @@
 import com.fasterxml.jackson.annotation.JsonProperty;
 
-import geniusweb.protocol.session.OnePartyTeam;
 import geniusweb.protocol.session.SessionSettings;
-import geniusweb.protocol.session.TeamOfPartiesAndProfiles;
-import geniusweb.protocol.session.amop.AMOPSettings;
-import geniusweb.protocol.session.mopac.MOPACSettings;
+import geniusweb.protocol.session.TeamInfo;
 import geniusweb.protocol.session.saop.SAOPSettings;
 import geniusweb.protocol.session.shaop.SHAOPSettings;
-import geniusweb.protocol.session.shaop.ShaopTeam;
 import geniusweb.protocol.tournament.TournamentProtocol;
 import geniusweb.protocol.tournament.TournamentSettings;
+import geniusweb.references.PartyWithParameters;
 import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
 import tudelft.utilities.immutablelist.FixedList;
 import tudelft.utilities.immutablelist.ImmutableList;
@@ -82,7 +81,7 @@
 	 * @param teamsPerSession number of parties per session, must be at least 2.
 	 * @param sesettings      The generic {@link SessionSettings}.
-	 *                        {@link SessionSettings#with(TeamOfPartiesAndProfiles)}
+	 *                        {@link SessionSettings#with(TeamInfo)}
 	 *                        will be used to add the required
-	 *                        {@link TeamOfPartiesAndProfiles}s
+	 *                        {@link TeamInfo}s
 	 * @param nTournaments    the number of times the tournament should be run.
 	 */
@@ -105,14 +104,5 @@
 		if (nTournaments <= 0)
 			throw new IllegalArgumentException("nTournaments must be >0");
-		int teamsize;
-		if (sesettings instanceof SAOPSettings
-				|| sesettings instanceof MOPACSettings
-				|| sesettings instanceof AMOPSettings)
-			teamsize = 1;
-		else if (sesettings instanceof SHAOPSettings)
-			teamsize = 2;
-		else
-			throw new IllegalArgumentException(
-					"Unsupported protocol " + sesettings.getClass());
+		int teamsize = sesettings.getTeamSize();
 
 		for (Team team : teams) {
@@ -156,5 +146,5 @@
 	 */
 	public ImmutableList<SessionSettings> permutations() {
-		ImmutableList<ImmutableList<TeamOfPartiesAndProfiles>> partylistlist;
+		ImmutableList<ImmutableList<TeamInfo>> partylistlist;
 		ImmutableList<Team> partieslist = new FixedList<Team>(teams);
 		ImmutableList<ProfileList> profileslist = new FixedList<ProfileList>(
@@ -227,7 +217,7 @@
 	 */
 	private SessionSettings createSetting(
-			ImmutableList<TeamOfPartiesAndProfiles> partyproflist) {
+			ImmutableList<TeamInfo> partyproflist) {
 		SessionSettings settings = sessionsettings;
-		for (TeamOfPartiesAndProfiles partyprof : partyproflist) {
+		for (TeamInfo partyprof : partyproflist) {
 			settings = settings.with(partyprof);
 		}
@@ -242,9 +232,9 @@
 	 * @param drawPartyWithPutback if parties can be drawn multiple times
 	 * @return list of sessionsets where each sessionset contains settings for a
-	 *         session: a list with {@link TeamOfPartiesAndProfiles}s. The
+	 *         session: a list with {@link TeamInfo}s. The
 	 *         sessionsets are made by making all combinations of parties and
 	 *         profiles. Profiles are drawn with replace.
 	 */
-	private ImmutableList<ImmutableList<TeamOfPartiesAndProfiles>> getParticipants(
+	private ImmutableList<ImmutableList<TeamInfo>> getParticipants(
 			ImmutableList<Team> parties, ImmutableList<ProfileList> profiles,
 			int n, boolean drawPartyWithPutback) {
@@ -265,7 +255,7 @@
 				partiesPermutations, profilesPermutations);
 
-		MapList<Tuple<ImmutableList<Team>, ImmutableList<ProfileList>>, ImmutableList<TeamOfPartiesAndProfiles>> tournamentsettings = new MapList<Tuple<ImmutableList<Team>, ImmutableList<ProfileList>>, ImmutableList<TeamOfPartiesAndProfiles>>(
+		MapList<Tuple<ImmutableList<Team>, ImmutableList<ProfileList>>, ImmutableList<TeamInfo>> tournamentsettings = new MapList<Tuple<ImmutableList<Team>, ImmutableList<ProfileList>>, ImmutableList<TeamInfo>>(
 				tuple -> teamlist(tuple), tuples);
-		return new Repeat<ImmutableList<TeamOfPartiesAndProfiles>>(
+		return new Repeat<ImmutableList<TeamInfo>>(
 				tournamentsettings, BigInteger.valueOf(numberTournaments),
 				true);
@@ -279,29 +269,27 @@
 	 *         in order.
 	 */
-	private ImmutableList<TeamOfPartiesAndProfiles> teamlist(
+	private ImmutableList<TeamInfo> teamlist(
 			Tuple<ImmutableList<Team>, ImmutableList<ProfileList>> tuple) {
-		BiFunction<Team, ProfileList, TeamOfPartiesAndProfiles> makeparty = new BiFunction<Team, ProfileList, TeamOfPartiesAndProfiles>() {
+		BiFunction<Team, ProfileList, TeamInfo> makeparty = new BiFunction<Team, ProfileList, TeamInfo>() {
 			@Override
-			public TeamOfPartiesAndProfiles apply(Team team,
+			public TeamInfo apply(Team team,
 					ProfileList profilelist) {
-				if (sessionsettings instanceof SAOPSettings
-						|| sessionsettings instanceof AMOPSettings
-						|| sessionsettings instanceof MOPACSettings)
-					return new OnePartyTeam(team.getParties().get(0),
-							profilelist.getProfiles().get(0));
-				else if (sessionsettings instanceof SHAOPSettings) {
-					return new ShaopTeam(
-							new PartyWithProfile(team.getParties().get(0),
-									profilelist.getProfiles().get(0)),
-							new PartyWithProfile(team.getParties().get(1),
-									profilelist.getProfiles().get(1)));
-				} else
+				List<PartyWithParameters> parties = team.getParties();
+				List<ProfileRef> profiles = profilelist.getProfiles();
+				if (parties.size() != profiles.size())
 					throw new IllegalArgumentException(
-							"Unknown/unsupported protocol "
-									+ sessionsettings.getClass());
+							"Parties and profiles list must match, but found "
+									+ team + " and " + profilelist);
+
+				List<PartyWithProfile> theteams = new LinkedList<>();
+				for (int n = 0; n < parties.size(); n++) {
+					theteams.add(new PartyWithProfile(parties.get(n),
+							profiles.get(n)));
+				}
+				return new TeamInfo(theteams);
 			}
 
 		};
-		return new MapThreadList<TeamOfPartiesAndProfiles, Team, ProfileList>(
+		return new MapThreadList<TeamInfo, Team, ProfileList>(
 				makeparty, tuple.get1(), tuple.get2());
 	}
Index: protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java	(revision 29)
+++ protocol/src/test/java/geniusweb/protocol/session/DefaultSessionStateTest.java	(revision 30)
@@ -41,5 +41,5 @@
 	private DefaultSessionState1 state1, state1a, stateA, stateE, stateF;
 	// The 1 is because we are testing an instance, not the abstract class
-	private String state1string = "{\"DefaultSessionState1\":{\"actions\":[],\"progress\":{\"time\":{\"duration\":1000,\"start\":1000}},\"settings\":{\"SAOPSettings\":{\"participants\":[{\"party\":{\"partyref\":\"party1\",\"parameters\":{}},\"profile\":\"profile1\"},{\"party\":{\"partyref\":\"party2\",\"parameters\":{}},\"profile\":\"profile2\"}],\"deadline\":{\"deadlinetime\":{\"durationms\":1000}}}},\"error\":null,\"partyprofiles\":{\"party1\":{\"party\":{\"partyref\":\"party1\",\"parameters\":{}},\"profile\":\"profile1\"}}}}";
+	private String state1string = "{\"DefaultSessionState1\":{\"actions\":[],\"progress\":{\"time\":{\"duration\":1000,\"start\":1000}},\"settings\":{\"SAOPSettings\":{\"participants\":[{\"TeamInfo\":{\"parties\":[{\"party\":{\"partyref\":\"party1\",\"parameters\":{}},\"profile\":\"profile1\"}]}},{\"TeamInfo\":{\"parties\":[{\"party\":{\"partyref\":\"party2\",\"parameters\":{}},\"profile\":\"profile2\"}]}}],\"deadline\":{\"deadlinetime\":{\"durationms\":1000}}}},\"error\":null,\"partyprofiles\":{\"party1\":{\"party\":{\"partyref\":\"party1\",\"parameters\":{}},\"profile\":\"profile1\"}}}}";
 	private ProgressTime progr;
 	private final Date start = new Date(1000l);
@@ -60,7 +60,7 @@
 				new PartyRef("party2"), new Parameters());
 		ProfileRef profile2 = new ProfileRef("profile2");
-		List<OnePartyTeam> participants = Arrays.asList(
-				new OnePartyTeam(party1ref, profile1),
-				new OnePartyTeam(party2ref, profile2));
+		List<TeamInfo> participants = Arrays.asList(
+				new TeamInfo(party1ref, profile1),
+				new TeamInfo(party2ref, profile2));
 		SessionSettings settings = new SAOPSettings(participants, deadline);
 		ProtocolException e = new ProtocolException("test protocol error",
Index: protocol/src/test/java/geniusweb/protocol/session/TeamInfoTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/session/TeamInfoTest.java	(revision 30)
+++ protocol/src/test/java/geniusweb/protocol/session/TeamInfoTest.java	(revision 30)
@@ -0,0 +1,73 @@
+package geniusweb.protocol.session;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyRef;
+import geniusweb.references.PartyWithParameters;
+import geniusweb.references.ProfileRef;
+import tudelft.utilities.junit.GeneralTests;
+
+public class TeamInfoTest extends GeneralTests<TeamInfo> {
+
+	private TeamInfo team1 = new TeamInfo(Collections.emptyList());
+	private TeamInfo team1a = new TeamInfo(Collections.emptyList());
+	private PartyRef partyref;
+	private Parameters parameters = new Parameters();;
+	private ProfileRef profileref;
+	private TeamInfo team2, team2a;
+	private String asString1 = "{\"TeamInfo\":{\"parties\":[{\"party\":{\"partyref\":\"party1\",\"parameters\":{}},\"profile\":\"profile1\"}]}}";
+
+	@Before
+	public void before() throws URISyntaxException {
+		partyref = new PartyRef("party1");
+		profileref = new ProfileRef("profile1");
+		team2 = new TeamInfo(new PartyWithParameters(partyref, parameters),
+				profileref);
+		team2a = new TeamInfo(new PartyWithParameters(partyref, parameters),
+				profileref);
+
+	}
+
+	@Override
+	public List<List<TeamInfo>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(team1, team1a),
+				Arrays.asList(team2, team2a));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("TeamInfo.\\[\\].",
+				"TeamInfo.\\[PartyWithProfile.*party1.*profile1.*\\].*");
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+
+		ObjectMapper jackson = new ObjectMapper();
+		System.out.println(jackson.writeValueAsString(team2));
+		assertEquals(asString1, jackson.writeValueAsString(team2));
+
+	}
+
+	@Test
+	public void testDeserialize() throws IOException {
+
+		ObjectMapper jackson = new ObjectMapper();
+		TeamInfo read = jackson.readValue(asString1, TeamInfo.class);
+		assertEquals(team2, read);
+	}
+
+}
